#! /bin/bash

# For the GeForce 940M gpu (Maxwell architecture) in my laptop, lib/gpu is compiled using 
# mixed precsion, CUDA_PRECISION = -D_SINGLE_DOUBLE
# CUDA_ARCH = -arch=sm_50, 
# The lammps is a version of 5May2018. It is compiled fully using intel compiler (parallel studio 2017)

# Refer to https://lammps.sandia.gov/doc/Build_extras.html to set the value for -arch=sm_xx
# sm_20 for Fermi (C2050/C2070, deprecated as of CUDA 8.0) or GeForce GTX 580 or similar
# sm_30 for Kepler (K10)
# sm_35 for Kepler (K40) or GeForce GTX Titan or similar
# sm_37 for Kepler (dual K80)
# sm_50 for Maxwell
# sm_60 for Pascal (P100)
# sm_70 for Volta
mpirun=mpirun ### dont uncomment; default otherwise stated; This is intel mpirun

#########################
#########################
omp=1
np=2
gpu=2

### default 1 2 2; (best performance with least resources spent; tested on anatta)

#mpirun=mpirun  ### Default choice for mpirun. This is intel version mpirun. 
lmp=/share/apps/local/bin/lmp_igpu  ### gpu-enabled lmp works, compiled in ~/share/apps/lammps-16Mar18/src/lmp_igpu

#lmp=/home/tlyoon/share/apps/lammps-16Mar18/src/lmp_intel_cpu_intelmpi
#mpirun=/share/apps/openmpi-1.8.5/intel/bin/mpirun
#lmp=/share/apps/local/bin/lmp_gnu
#mpirun=/home/tlyoon/ii/openmpi-2.1.1/bin/mpirun
#lmp=/home/tlyoon/ii/lammps_5May15/src/lmp_gnu
#mpirun=~/ii/openmpi-2.1.1/bin/mpirun
#mpirun=/share/apps/openmpi-3.1.2/intel/bin/mpirun
#mpirun=/home/tlyoon/share/apps/pgi/linux86-64/2018/mpi/openmpi-2.1.2/bin/mpirun

# export OMP_NUM_THREADS=$omp; mpirun -np $np $lmp -sf gpu -pk gpu $gpu tpa 8 < in.lr_qa

export OMP_NUM_THREADS=$omp; $mpirun -np $np $lmp -sf gpu -pk gpu $gpu tpa 8 < in.lj.5.0

#export OMP_NUM_THREADS=$omp; mpirun -np $np $lmp -sf gpu -pk gpu $gpu tpa 8 < in.phosphate

#export OMP_NUM_THREADS=$omp; $mpirun -np $np $lmp -sf gpu -pk gpu $gpu tpa 8 < in.rhodo

### Note: Tested on annatta, with lammps versioin 5May2018 compiled with pure intel compiler; gpu lib compiled with cuda-9.2; -arch=sm_60
### Optimal parameters to run the lammps in gpu mode in anatta are determined to be:
### omp=1; np=2; gpu=2; lmp_igpu; intel mpirun

